#include <iostream>

using namespace std;

int main()
{
    int brojPac;
    bool proslo = false;
    bool proslouFORU = false;
    int brojO_krvi, brojA_krvi;
    int kolikoDatiO, kolikoDatiA;
    string KrvnaGrupa;
    int kolikoKrvi;
    cin >> brojPac;
    cin >> brojO_krvi >> brojA_krvi;
    for (int p = 0; p < brojPac; p++)
    {
        cin >> KrvnaGrupa >> kolikoKrvi;
        if (KrvnaGrupa == "O")
        {
            if (kolikoKrvi < brojO_krvi)
            {
                kolikoDatiO = kolikoKrvi;
                proslouFORU = true;
            }
        }
        else if (KrvnaGrupa == "A")
        {
            if(brojA_krvi >= kolikoKrvi)
            {
                kolikoDatiA = kolikoKrvi;
                proslouFORU = true;

            }
            else if(brojA_krvi < kolikoKrvi && brojA_krvi + brojO_krvi > kolikoKrvi)
            {

            }
        }
    }

    if(kolikoKrvi > brojO_krvi)
    {
        cout << "nemoguce";
        proslo = true;
    }

    if(kolikoKrvi > brojA_krvi || kolikoKrvi > brojO_krvi || kolikoKrvi > brojO_krvi + brojA_krvi)
    {
        if (proslo == false) cout << "nemoguce";
    }
    if (proslouFORU == true)
    {
        cout << "moguce";
        cout << kolikoDatiO << 0 << endl;
        cout << 0 << kolikoDatiA;
    }

    return 0;
}